/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Vista;

import Controlador.UsuarioCon;
import Controlador.UsuarioCon.Nodo;
import Gestorarchivos.GestorUsuario;
import Modelo.LoginUsuario;
import java.util.StringTokenizer;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Usuario
 */
public class RegistroUsuarioFrm extends javax.swing.JFrame {
    DefaultTableModel modelo;
    String[] cabecera = {"IDENTIFICADOR", "USUARIO", "CONSTRASEÑA"};
    String[][] data = {};
    int num = 0, tam;
    GestorUsuario gestor = new GestorUsuario();
    String FileName = "login.bin";
    UsuarioCon lista = new UsuarioCon();
    Nodo nodo;
    public RegistroUsuarioFrm() {
        initComponents();    
        gestor.AbrirArchivo(FileName, lista);
        tam = 0;
        modelo = new DefaultTableModel(data, cabecera);
        TblRegistro.setModel(modelo);
        verdatos();
        this.setLocationRelativeTo(null);
        this.setTitle("REGISTRO DE USUARIOS");
        TblRegistro.setEnabled(false);
        this.setResizable(false);
    }

    //METODOS LOCOS
    public String Eliminar() {
        String eliminado = "";
        Nodo aux = lista.inicio;
        String usu = aux.getUsu().getUsuario();
        String pass = aux.getUsu().getContraseña();
        eliminado = usu + "," + String.valueOf(pass);
        lista.inicio = lista.inicio.getSigui();
        aux.setSigui(null);
        return eliminado;

    }

    public void mensaje(String data) {
        StringTokenizer st = new StringTokenizer(data, ",");
        String usu = st.nextToken();
        String pass = st.nextToken();

        String datos = "DETALLES DEL USUARIO ELIMINADO:\n"
                + "-->USUARIO:" + usu + "\n"
                + "-->CONSTRASEÑA:" + pass + "\n";
        JOptionPane.showMessageDialog(this, datos);
    }

    void vaciartabla() {
        int filas = TblRegistro.getRowCount();
        for (int i = 0; i < filas; i++) {
            modelo.removeRow(0);
        }
    }

    public int Numelem() {
        int num = 0;
        Nodo aux = lista.inicio;
        while (aux != null) {
            num++;
            aux = aux.getSigui();
        }
        return num;
    }

    public void verdatos() {
        String usuar;
        String passwor;
        Nodo aux = lista.inicio;
        vaciartabla();
        Nodo p;
        num = Numelem();
        while (aux != null) {
            usuar = aux.getUsu().getUsuario();
            passwor = aux.getUsu().getContraseña();

            Object[] fila = {num, usuar, passwor};
            num--;
            modelo.addRow(fila);
            aux = aux.getSigui();
        }
    }

    public Nodo Buscar(Nodo tope, String usuar) {
        Nodo pos = tope;
        while (pos != null && !usuar.equalsIgnoreCase(pos.getUsu().getUsuario())) {
            pos = pos.getSigui();
        }
        return pos;
    }

    public Nodo Buscar2(Nodo tope, String passwor) {
        Nodo pos = tope;
        while (pos != null && !passwor.equalsIgnoreCase(String.valueOf(pos.getUsu().getContraseña()))) {
            pos = pos.getSigui();
        }
        return pos;
    }

    void limpiacampos() {
        txtusuario.setText("");
        txtcontrasena.setText("");
        txtusuario.requestFocus();
        
    }

    void habilitar() {
        BtnRegistrar.setEnabled(false);
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtusuario = new javax.swing.JTextField();
        txtcontrasena = new javax.swing.JTextField();
        BtnRegistrar = new javax.swing.JButton();
        BtnRegresar = new javax.swing.JButton();
        BtnBuscar = new javax.swing.JButton();
        BtnEliminar = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        TblRegistro = new javax.swing.JTable();

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Usuario");

        jLabel2.setText("Contraseña");

        BtnRegistrar.setText("Registra");
        BtnRegistrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtnRegistrarActionPerformed(evt);
            }
        });

        BtnRegresar.setText("Regresar");
        BtnRegresar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtnRegresarActionPerformed(evt);
            }
        });

        BtnBuscar.setText("Buscar");
        BtnBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtnBuscarActionPerformed(evt);
            }
        });

        BtnEliminar.setText("Eliminar");
        BtnEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtnEliminarActionPerformed(evt);
            }
        });

        TblRegistro.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        jScrollPane2.setViewportView(TblRegistro);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(54, 54, 54)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(76, 76, 76)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(txtcontrasena, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE)
                            .addComponent(txtusuario)))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGap(46, 46, 46)
                            .addComponent(BtnRegistrar)
                            .addGap(35, 35, 35)
                            .addComponent(BtnBuscar)
                            .addGap(33, 33, 33)
                            .addComponent(BtnEliminar)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(BtnRegresar))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGap(73, 73, 73)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 379, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(67, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtusuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(txtcontrasena, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 45, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BtnBuscar)
                    .addComponent(BtnRegistrar)
                    .addComponent(BtnEliminar)
                    .addComponent(BtnRegresar))
                .addGap(34, 34, 34)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(39, 39, 39))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void BtnBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnBuscarActionPerformed
String usuar = txtusuario.getText();
        if (usuar.equalsIgnoreCase("")) {
            JOptionPane.showMessageDialog(this, "INGRESE UN NOMBRE EN EL CAMPO USUARIO", "INFORMACION", JOptionPane.INFORMATION_MESSAGE);
            txtusuario.requestFocus();
        } else {
            lista.nodo1 = Buscar(lista.inicio, usuar);
            if (lista.nodo1 != null) {
                txtusuario.setText(lista.nodo1.getUsu().getUsuario());
                txtcontrasena.setText(String.valueOf(lista.nodo1.getUsu().getContraseña()));
                habilitar();
            } else {
                JOptionPane.showMessageDialog(this, "EL USUARIO: " + usuar + " NO ESTA EN LA PILA");
            }
        }
    }//GEN-LAST:event_BtnBuscarActionPerformed

    private void BtnRegistrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnRegistrarActionPerformed
          if (txtusuario.getText().isEmpty() && txtcontrasena.getText().isEmpty() ) {
            JOptionPane.showMessageDialog(null, "¡DEBE LLENAR TODOS LOS DATOS!", "ALERTA", JOptionPane.WARNING_MESSAGE);
        } else {
            String usuar = txtusuario.getText();
            String passwor = txtcontrasena.getText();
            lista.push(new LoginUsuario(new Object[]{usuar, passwor}));
            try {
                StringBuffer usuarios = new StringBuffer(txtusuario.getText().trim() + " " + txtcontrasena.getText().trim() + "\t");
                GestorUsuario.EscribeTxt(usuarios);
            } catch (Exception e) {
            }
            tam = tam + 1;
            limpiacampos();
            verdatos();
            gestor.GrabarArchivo(FileName, lista);

        }
    }//GEN-LAST:event_BtnRegistrarActionPerformed

    private void BtnEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnEliminarActionPerformed
          if (lista.inicio == null) {
            JOptionPane.showMessageDialog(this, "¡PILA VACIA!");
            txtusuario.requestFocus();
        } else {
            String dato = Eliminar();
            mensaje(dato);
            gestor.GrabarArchivo(FileName, lista);
            verdatos();
            limpiacampos();
            if (lista.inicio == null) {
                JOptionPane.showMessageDialog(this, "¡PILA VACIA!");
            }

        }
    }//GEN-LAST:event_BtnEliminarActionPerformed

    private void BtnRegresarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnRegresarActionPerformed
        Login loyin = new Login();
        loyin.setVisible(true);
        dispose();
    }//GEN-LAST:event_BtnRegresarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(RegistroUsuarioFrm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(RegistroUsuarioFrm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(RegistroUsuarioFrm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(RegistroUsuarioFrm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new RegistroUsuarioFrm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BtnBuscar;
    private javax.swing.JButton BtnEliminar;
    private javax.swing.JButton BtnRegistrar;
    private javax.swing.JButton BtnRegresar;
    private javax.swing.JTable TblRegistro;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField txtcontrasena;
    private javax.swing.JTextField txtusuario;
    // End of variables declaration//GEN-END:variables
}
